
# Forgejo's entities' relations repo, organisation, team, user

## small: only one comment

![alt text](org-repo-user-small.png)

## normal model

![alt text](org-repo-user.png)

## large

![alt text](org-repo-user-large.png)

## large packaged

![alt text](org-repo-user-large-packaged.png)


Das `owners`-Team in Gitea/Forgejo ist **etwas Besonderes** und tatsächlich **hardcoded** – hier sind die Details:

---

## 🧠 Bedeutung des `owners` Teams

### 🟩 Es ist **automatisch vorhanden**

* Jede Organisation hat immer ein Team namens `owners`.
* Dieses Team wird **automatisch erstellt**, wenn die Organisation erstellt wird.

### 🔐 Es hat **immer Admin-Rechte**

* Mitglieder des `owners`-Teams haben **volle Admin-Rechte** auf:

  * alle Repositories der Organisation
  * alle Teams
  * die Organisation selbst (z. B. Mitgliederverwaltung, Einstellungen)
* Rechte können **nicht reduziert** oder **entfernt** werden.
* Nur Mitglieder dieses Teams können:

  * neue Teams erstellen oder löschen
  * andere Mitglieder zum `owners`-Team hinzufügen oder entfernen

### 🔒 Sicherheitsrelevant

* Dieses Team steuert **letztlich die Kontrolle über die gesamte Organisation**.
* Es ist vergleichbar mit „Org Admins“.

---

## 🔧 Muss ich das `owners`-Team konfigurieren?

### Nein – aber:

* Du **musst es nicht konfigurieren**, es funktioniert immer.
* Du **kannst Mitglieder hinzufügen oder entfernen**, aber **nicht das Team selbst löschen oder umbenennen**.

### ✅ Empfehlungen:

* Nur vertrauenswürdige Personen (z. B. Projekt-Admins) sollten im `owners`-Team sein.
* Für andere Rollen (Contributor, Maintainer, Leser) solltest du **eigene Teams** mit passenden Rechten erstellen.

---

## 📘 Beispiel: Organisation mit klarer Rollentrennung

| Team           | Beschreibung              | Rechte                     |
| -------------- | ------------------------- | -------------------------- |
| `owners`       | Orga-Admins (hartkodiert) | Admin                      |
| `maintainers`  | Aktive Maintainer         | Admin/Write je nach Bedarf |
| `contributors` | Beitragende Entwickler    | Write                      |
| `readers`      | Dürfen nur lesen          | Read                       |

---

Wenn du möchtest, kann ich dir auch ein Skript bauen, das sicherstellt:

* Nur bestimmte Benutzer im `owners`-Team sind
* Alle anderen automatisch in passende andere Teams sortiert werden

Möchtest du so ein Beispiel oder ein Review-Skript für Orga-Mitglieder und deren Rechte?
